import { AnimationEvent } from '@angular/animations';
import { AfterContentInit, AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, NgZone, OnDestroy, OnInit, QueryList, Renderer2, TemplateRef } from '@angular/core';
import { Footer, Header, PrimeNGConfig } from 'primeng/api';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "primeng/focustrap";
import * as i3 from "primeng/ripple";
import * as i4 from "primeng/icons/times";
import * as i5 from "primeng/icons/windowmaximize";
import * as i6 from "primeng/icons/windowminimize";
import * as i7 from "primeng/api";
export declare class Dialog implements AfterContentInit, OnInit, OnDestroy, AfterViewInit {
    private document;
    private platformId;
    el: ElementRef;
    renderer: Renderer2;
    zone: NgZone;
    private cd;
    config: PrimeNGConfig;
    header: string;
    draggable: boolean;
    resizable: boolean;
    get positionLeft(): number;
    set positionLeft(_positionLeft: number);
    get positionTop(): number;
    set positionTop(_positionTop: number);
    contentStyle: any;
    contentStyleClass: string;
    modal: boolean;
    closeOnEscape: boolean;
    dismissableMask: boolean;
    rtl: boolean;
    closable: boolean;
    get responsive(): boolean;
    set responsive(_responsive: boolean);
    appendTo: any;
    breakpoints: any;
    styleClass: string;
    maskStyleClass: string;
    showHeader: boolean;
    get breakpoint(): number;
    set breakpoint(_breakpoint: number);
    blockScroll: boolean;
    autoZIndex: boolean;
    baseZIndex: number;
    minX: number;
    minY: number;
    focusOnShow: boolean;
    maximizable: boolean;
    keepInViewport: boolean;
    focusTrap: boolean;
    transitionOptions: string;
    closeIcon: string;
    closeAriaLabel: string;
    closeTabindex: string;
    minimizeIcon: string;
    maximizeIcon: string;
    headerFacet: QueryList<Header>;
    footerFacet: QueryList<Footer>;
    templates: QueryList<any>;
    headerViewChild: ElementRef;
    contentViewChild: ElementRef;
    footerViewChild: ElementRef;
    onShow: EventEmitter<any>;
    onHide: EventEmitter<any>;
    visibleChange: EventEmitter<any>;
    onResizeInit: EventEmitter<any>;
    onResizeEnd: EventEmitter<any>;
    onDragEnd: EventEmitter<any>;
    onMaximize: EventEmitter<any>;
    headerTemplate: TemplateRef<any>;
    contentTemplate: TemplateRef<any>;
    footerTemplate: TemplateRef<any>;
    maximizeIconTemplate: TemplateRef<any>;
    closeIconTemplate: TemplateRef<any>;
    minimizeIconTemplate: TemplateRef<any>;
    _visible: boolean;
    maskVisible: boolean;
    container: HTMLDivElement;
    wrapper: HTMLElement;
    dragging: boolean;
    documentDragListener: VoidFunction | null;
    documentDragEndListener: VoidFunction | null;
    resizing: boolean;
    documentResizeListener: VoidFunction | null;
    documentResizeEndListener: VoidFunction | null;
    documentEscapeListener: VoidFunction | null;
    maskClickListener: VoidFunction | null;
    lastPageX: number;
    lastPageY: number;
    preventVisibleChangePropagation: boolean;
    maximized: boolean;
    preMaximizeContentHeight: number;
    preMaximizeContainerWidth: number;
    preMaximizeContainerHeight: number;
    preMaximizePageX: number;
    preMaximizePageY: number;
    id: string;
    _style: any;
    _position: string;
    originalStyle: any;
    transformOptions: any;
    styleElement: any;
    private window;
    constructor(document: Document, platformId: any, el: ElementRef, renderer: Renderer2, zone: NgZone, cd: ChangeDetectorRef, config: PrimeNGConfig);
    ngAfterContentInit(): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    get visible(): any;
    set visible(value: any);
    get style(): any;
    set style(value: any);
    get position(): string;
    set position(value: string);
    focus(): void;
    close(event: Event): void;
    enableModality(): void;
    disableModality(): void;
    maximize(): void;
    unbindMaskClickListener(): void;
    moveOnTop(): void;
    createStyle(): void;
    initDrag(event: MouseEvent): void;
    onKeydown(event: KeyboardEvent): void;
    onDrag(event: MouseEvent): void;
    endDrag(event: MouseEvent): void;
    resetPosition(): void;
    center(): void;
    initResize(event: MouseEvent): void;
    onResize(event: MouseEvent): void;
    resizeEnd(event: any): void;
    bindGlobalListeners(): void;
    unbindGlobalListeners(): void;
    bindDocumentDragListener(): void;
    unbindDocumentDragListener(): void;
    bindDocumentDragEndListener(): void;
    unbindDocumentDragEndListener(): void;
    bindDocumentResizeListeners(): void;
    unbindDocumentResizeListeners(): void;
    bindDocumentEscapeListener(): void;
    unbindDocumentEscapeListener(): void;
    appendContainer(): void;
    restoreAppend(): void;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationEnd(event: AnimationEvent): void;
    onContainerDestroy(): void;
    destroyStyle(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<Dialog, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Dialog, "p-dialog", never, { "header": "header"; "draggable": "draggable"; "resizable": "resizable"; "positionLeft": "positionLeft"; "positionTop": "positionTop"; "contentStyle": "contentStyle"; "contentStyleClass": "contentStyleClass"; "modal": "modal"; "closeOnEscape": "closeOnEscape"; "dismissableMask": "dismissableMask"; "rtl": "rtl"; "closable": "closable"; "responsive": "responsive"; "appendTo": "appendTo"; "breakpoints": "breakpoints"; "styleClass": "styleClass"; "maskStyleClass": "maskStyleClass"; "showHeader": "showHeader"; "breakpoint": "breakpoint"; "blockScroll": "blockScroll"; "autoZIndex": "autoZIndex"; "baseZIndex": "baseZIndex"; "minX": "minX"; "minY": "minY"; "focusOnShow": "focusOnShow"; "maximizable": "maximizable"; "keepInViewport": "keepInViewport"; "focusTrap": "focusTrap"; "transitionOptions": "transitionOptions"; "closeIcon": "closeIcon"; "closeAriaLabel": "closeAriaLabel"; "closeTabindex": "closeTabindex"; "minimizeIcon": "minimizeIcon"; "maximizeIcon": "maximizeIcon"; "visible": "visible"; "style": "style"; "position": "position"; }, { "onShow": "onShow"; "onHide": "onHide"; "visibleChange": "visibleChange"; "onResizeInit": "onResizeInit"; "onResizeEnd": "onResizeEnd"; "onDragEnd": "onDragEnd"; "onMaximize": "onMaximize"; }, ["headerFacet", "footerFacet", "templates"], ["p-header", "*", "p-footer"], false, never>;
}
export declare class DialogModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DialogModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DialogModule, [typeof Dialog], [typeof i1.CommonModule, typeof i2.FocusTrapModule, typeof i3.RippleModule, typeof i4.TimesIcon, typeof i5.WindowMaximizeIcon, typeof i6.WindowMinimizeIcon], [typeof Dialog, typeof i7.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DialogModule>;
}
